diff --git a/src/backend/postmaster/postmaster.c b/src/backend/postmaster/postmaster.c
index d6133bfebc6..4c95376648d 100644
--- a/src/backend/postmaster/postmaster.c
+++ b/src/backend/postmaster/postmaster.c
@@ -110,11 +110,15 @@
 #include "replication/slotsync.h"
 #include "replication/walsender.h"
 #include "storage/aio_subsys.h"
+#include "storage/bufmgr.h"
 #include "storage/fd.h"
 #include "storage/io_worker.h"
 #include "storage/ipc.h"
+#include "storage/pg_shmem.h"
 #include "storage/pmsignal.h"
 #include "storage/proc.h"
+#include "storage/procsignal.h"
+#include "storage/shmem.h"
 #include "tcop/backend_startup.h"
 #include "tcop/tcopprot.h"
 #include "utils/datetime.h"
@@ -125,7 +129,6 @@
 
 #ifdef EXEC_BACKEND
 #include "common/file_utils.h"
-#include "storage/pg_shmem.h"
 #endif
 
 
@@ -958,6 +961,11 @@ PostmasterMain(int argc, char *argv[])
 	 */
 	InitializeFastPathLocks();
 
+	/*
+	 * Calculate MaxNBuffers for buffer pool resizing.
+	 */
+	InitializeMaxNBuffers();
+
 	/*
 	 * Give preloaded libraries a chance to request additional shared memory.
 	 */
diff --git a/src/backend/storage/aio/aio_init.c b/src/backend/storage/aio/aio_init.c
index d3c68d8b04c..b8dac7eb9d5 100644
--- a/src/backend/storage/aio/aio_init.c
+++ b/src/backend/storage/aio/aio_init.c
@@ -101,7 +101,7 @@ AioChooseMaxConcurrency(void)
 
 	/* Similar logic to LimitAdditionalPins() */
 	max_backends = MaxBackends + NUM_AUXILIARY_PROCS;
-	max_proportional_pins = NBuffers / max_backends;
+	max_proportional_pins = NBuffersPending / max_backends;
 
 	max_proportional_pins = Max(max_proportional_pins, 1);
 
diff --git a/src/backend/storage/buffer/Makefile b/src/backend/storage/buffer/Makefile
index fd7c40dcb08..3bc9aee85de 100644
--- a/src/backend/storage/buffer/Makefile
+++ b/src/backend/storage/buffer/Makefile
@@ -17,6 +17,7 @@ OBJS = \
 	buf_table.o \
 	bufmgr.o \
 	freelist.o \
-	localbuf.o
+	localbuf.o \
+	buf_resize.o
 
 include $(top_srcdir)/src/backend/common.mk
diff --git a/src/backend/storage/buffer/README b/src/backend/storage/buffer/README
index 119f31b5d65..5dd753718a0 100644
--- a/src/backend/storage/buffer/README
+++ b/src/backend/storage/buffer/README
@@ -261,3 +261,77 @@ As of 8.4, background writer starts during recovery mode when there is
 some form of potentially extended recovery to perform. It performs an
 identical service to normal processing, except that checkpoints it
 writes are technically restartpoints.
+
+Resizing shared buffers at runtime
+----------------------------------
+
+Before <TODO: Add version>, the size of the shared buffer pool (i.e. the number
+of shared buffers) was given by the global variable NBuffers and was fixed at
+server start time using GUC shared_buffers. In order to change the size of the
+shared buffer pool, one needed to change the GUC and restart the server.
+Starting <TODO: add version> PostgreSQL supports resizing the buffer pool
+without a server restart. The new GUC variable max_shared_buffers defines the
+maximum size of the shared buffer pool. Existing GUC shared_buffers controls the
+size of the buffer pool at run time. See configure.sgml for more details about
+these GUCs.
+
+The buffer manager maintains following data structures in shared memory.
+1. Buffer Descriptors: An array of BufferDesc structures, one per buffer.
+2. Buffer Blocks: An array of buffer blocks, forming the buffer pool.
+3. Buffer Lookup Table: A hash table mapping a page to the buffer containing
+   that page.
+4. IO conditional variables: An array of conditional variables, one per buffer.
+5. Checkpoint buffer ids: An array of buffer ids used during checkpointing.
+
+Except for the hash table, all the above data structures are required to be
+allocated as contiguous memory chunks. The code also relies on their start
+addresses being stable throughout the server lifetime. Resizing these structures
+means stretching or shrinking their tails. This is done by a. reserving address
+spaces for each of these structures during server start up, b. allocating or
+deallocating physical memory pages as needed during resizing, and c.
+initializing the array elements in the newly allocated memory regions.
+
+TODO: Should the memory management strategy be documented here or somewhere near
+storage/pg_shmem.c or sysv_shmem.c?
+
+Following protocol is used to make each of the segments elastic in a system
+which supports anonymous shared memory segments (like Linux). For each of the
+segments:
+1. Allocate a file descriptor using memfd_create() system call.
+2. Reserve address space for the segment using mmap(), passing it the fd
+   obtained in the first step with PROT_NONE and MAP_NORESERVE flags.
+3. Change the protection of the whole address space to PROT_READ | PROT_WRITE
+   using mprotect().
+4. Allocate or deallocate physical memory pages using ftruncate() as needed.
+
+The first three steps are executed when starting the server. The last step is
+executed when starting the server and during resizing.
+
+We should ideally call mmap() with PROT_READ | PROT_WRITE and avoid calling
+mprotect() separately. However, on Linux, when using huge pages, mmap() with
+PROT_READ | PROT_WRITE allocates memory for the whole region even if
+MAP_NORESERVE is specified. Above sequence avoids this problem.
+
+We could use mmap and mremap to resize the segments. However these calls will
+need to be executed by each backend process as well as the postmaster when
+resizing. This requires additional Synchronization between the postmaster and
+the resizing coordinator and requires careful implementation to avoid missing a
+newly joining backend during resizing. Using memfd_create and ftruncate avoids
+this complexity as ftruncate can be called from only one process, usually the
+coordinator and the changes are visible to all other processes automatically.
+
+Global variables (like NBuffers before this change) are inherited by each
+backend from the postmaster. If we continue to rely on NBuffers to provide the
+size of the buffer pool at a given point in time, we need to involve the
+postmater in resizing. To avoid this complexity, we store the current size of
+the buffer pool in the shared structure ShmemCtrl (name subject to change) and
+change only that variable during resizing. We use ProcSignalBarrier to know when
+all backends have observed the new size after resizing.
+
+See CreateAnonymousSegment() and AnonymousShmemResize() for detailed
+implementation.
+
+To resize shared buffers at runtime a user performs the steps mentioned in the
+description of shared_buffers GUC variable in configure.sgml. Actual resizing
+protocol is documented in the prologue of function pg_resize_shared_buffers() in
+src/backend/storage/buffer/buf_resize.c
diff --git a/src/backend/storage/buffer/buf_init.c b/src/backend/storage/buffer/buf_init.c
index 42112109af9..d57c8bfb209 100644
--- a/src/backend/storage/buffer/buf_init.c
+++ b/src/backend/storage/buffer/buf_init.c
@@ -17,8 +17,8 @@
 #include "storage/aio.h"
 #include "storage/buf_internals.h"
 #include "storage/bufmgr.h"
-#include "storage/pg_shmem.h"
 #include "storage/proclist.h"
+#include "utils/guc.h"
 
 BufferDescPadded *BufferDescriptors;
 char	   *BufferBlocks;
@@ -63,6 +63,23 @@ CkptSortItem *CkptBufferIds;
  * to allow dynamic resizing of the buffer pool.
  */
 
+/*
+ * Initialize a single buffer.
+ */
+static void
+InitializeBuffer(int buf_id)
+{
+	BufferDesc *buf = GetBufferDescriptor(buf_id);
+
+	ClearBufferTag(&buf->tag);
+	pg_atomic_init_u64(&buf->state, 0);
+	buf->wait_backend_pgprocno = INVALID_PROC_NUMBER;
+	buf->buf_id = buf_id;
+	pgaio_wref_clear(&buf->io_wref);
+	proclist_init(&buf->lock_waiters);
+	ConditionVariableInit(BufferDescriptorGetIOCV(buf));
+}
+
 
 /*
  * Initialize shared buffer pool
@@ -77,24 +94,25 @@ BufferManagerShmemInit(void)
 				foundDescs,
 				foundIOCV,
 				foundBufCkpt;
+	int			i;
 
 	/* Align descriptors to a cacheline boundary. */
 	BufferDescriptors = (BufferDescPadded *)
 		ShmemInitStructInSegment("Buffer Descriptors",
-								 NBuffers * sizeof(BufferDescPadded),
+								 MaxNBuffers * sizeof(BufferDescPadded),
 								 &foundDescs, MAIN_SHMEM_SEGMENT);
 
 	/* Align buffer pool on IO page size boundary. */
 	BufferBlocks = (char *)
 		TYPEALIGN(PG_IO_ALIGN_SIZE,
 				  ShmemInitStructInSegment("Buffer Blocks",
-										   NBuffers * (Size) BLCKSZ + PG_IO_ALIGN_SIZE,
+										   NBuffersPending * (Size) BLCKSZ + PG_IO_ALIGN_SIZE,
 										   &foundBufs, BUFFERS_SHMEM_SEGMENT));
 
 	/* Align condition variables to cacheline boundary. */
 	BufferIOCVArray = (ConditionVariableMinimallyPadded *)
 		ShmemInitStructInSegment("Buffer IO Condition Variables",
-								 NBuffers * sizeof(ConditionVariableMinimallyPadded),
+								 MaxNBuffers * sizeof(ConditionVariableMinimallyPadded),
 								 &foundIOCV, MAIN_SHMEM_SEGMENT);
 
 	/*
@@ -106,46 +124,41 @@ BufferManagerShmemInit(void)
 	 */
 	CkptBufferIds = (CkptSortItem *)
 		ShmemInitStructInSegment("Checkpoint BufferIds",
-								 NBuffers * sizeof(CkptSortItem), &foundBufCkpt,
+								 MaxNBuffers * sizeof(CkptSortItem), &foundBufCkpt,
 								 MAIN_SHMEM_SEGMENT);
 
 	if (foundDescs || foundBufs || foundIOCV || foundBufCkpt)
 	{
 		/* should find all of these, or none of them */
 		Assert(foundDescs && foundBufs && foundIOCV && foundBufCkpt);
-		/* note: this path is only taken in EXEC_BACKEND case */
+
+		/*
+		 * note: this path is only taken in EXEC_BACKEND case when
+		 * initializing shared memory.
+		 */
 	}
 	else
 	{
-		int			i;
-
 		/*
 		 * Initialize all the buffer headers.
 		 */
-		for (i = 0; i < NBuffers; i++)
-		{
-			BufferDesc *buf = GetBufferDescriptor(i);
-
-			ClearBufferTag(&buf->tag);
-
-			pg_atomic_init_u64(&buf->state, 0);
-			buf->wait_backend_pgprocno = INVALID_PROC_NUMBER;
-
-			buf->buf_id = i;
-
-			pgaio_wref_clear(&buf->io_wref);
-
-			proclist_init(&buf->lock_waiters);
-			ConditionVariableInit(BufferDescriptorGetIOCV(buf));
-		}
+		for (i = 0; i < NBuffersPending; i++)
+			InitializeBuffer(i);
 	}
 
-	/* Init other shared buffer-management stuff */
+	/*
+	 * Init other shared buffer-management stuff.
+	 */
 	StrategyInitialize(!foundDescs);
 
 	/* Initialize per-backend file flush context */
 	WritebackContextInit(&BackendWritebackContext,
 						 &backend_flush_after);
+
+	/* Declare the size of current buffer pool. */
+	NBuffers = NBuffersPending;
+	pg_atomic_init_u32(&ShmemCtrl->currentNBuffers, NBuffersPending);
+	pg_atomic_init_u32(&ShmemCtrl->targetNBuffers, NBuffersPending);
 }
 
 /*
@@ -154,6 +167,10 @@ BufferManagerShmemInit(void)
  * compute the size of shared memory for the buffer pool including
  * data pages, buffer descriptors, hash tables, etc.
  *
+ * All the data structures except the buffer blocks are maximally allocated to
+ * accomodate a buffer pool of size MaxNBuffers. Only buffer blocks are
+ * allocated based on the initial size of the buffer pool (NBuffersPending).
+ *
  * The function adds the amount of required memory for buffer blocks to
  * BUFFERS_SHMEM_SEGMENT segment. Amount of memory required for other structures
  * is returned.
@@ -165,13 +182,15 @@ BufferManagerShmemSize(MemoryMappingSizes *mapping_sizes)
 
 	/* size of data pages, plus alignment padding */
 	size = add_size(0, PG_IO_ALIGN_SIZE);
-	size = add_size(size, mul_size(NBuffers, BLCKSZ));
+	size = add_size(size, mul_size(NBuffersPending, BLCKSZ));
 	mapping_sizes[BUFFERS_SHMEM_SEGMENT].shmem_req_size = size;
+	size = add_size(0, PG_IO_ALIGN_SIZE);
+	size = add_size(size, mul_size(MaxNBuffers, BLCKSZ));
 	mapping_sizes[BUFFERS_SHMEM_SEGMENT].shmem_reserved = size;
 
 	size = 0;
 	/* size of buffer descriptors */
-	size = add_size(size, mul_size(NBuffers, sizeof(BufferDescPadded)));
+	size = add_size(size, mul_size(MaxNBuffers, sizeof(BufferDescPadded)));
 	/* to allow aligning buffer descriptors */
 	size = add_size(size, PG_CACHE_LINE_SIZE);
 
@@ -179,13 +198,156 @@ BufferManagerShmemSize(MemoryMappingSizes *mapping_sizes)
 	size = add_size(size, StrategyShmemSize());
 
 	/* size of I/O condition variables */
-	size = add_size(size, mul_size(NBuffers,
+	size = add_size(size, mul_size(MaxNBuffers,
 								   sizeof(ConditionVariableMinimallyPadded)));
 	/* to allow aligning the above */
 	size = add_size(size, PG_CACHE_LINE_SIZE);
 
 	/* size of checkpoint sort array in bufmgr.c */
-	size = add_size(size, mul_size(NBuffers, sizeof(CkptSortItem)));
+	size = add_size(size, mul_size(MaxNBuffers, sizeof(CkptSortItem)));
 
 	return size;
 }
+
+/*
+ * Resize and reinitialize shared buffer manager structures when resizing the buffer pool.
+ *
+ * This function is called in the backend which coordinates buffer resizing
+ * operation.
+ */
+void
+BufferManagerShmemResize(int currentNBuffers, int targetNBuffers)
+{
+	bool		found;
+	int			i;
+	void	   *tmpPtr;
+
+	/*
+	 * The only resizable buffer manager structure is the buffer blocks. All
+	 * other structures are maximally allocated when the server starts.
+	 */
+	tmpPtr = (char *)
+		TYPEALIGN(PG_IO_ALIGN_SIZE,
+				  ShmemResizeStructInSegment("Buffer Blocks",
+											 targetNBuffers * (Size) BLCKSZ + PG_IO_ALIGN_SIZE,
+											 &found, BUFFERS_SHMEM_SEGMENT));
+	if (BufferBlocks != tmpPtr || !found)
+		elog(FATAL, "resizing buffer blocks failed: expected pointer %p, got %p, found=%d",
+			 BufferBlocks, tmpPtr, found);
+
+	/*
+	 * TODO: Initialize the headers for new buffers. If we are shrinking the
+	 * buffers, invalidate the extra buffers. If expanding initialize the new
+	 * buffers.
+	 */
+	for (i = currentNBuffers; i < targetNBuffers; i++)
+		InitializeBuffer(i);
+}
+
+/*
+ * BufferManagerShmemValidate
+ *		Validate that buffer manager shared memory structures have correct
+ *		pointers and sizes after a resize operation.
+ *
+ * This function is called by backends during ProcessBarrierShmemResizeStruct
+ * to ensure their view of the buffer structures is consistent after memory
+ * remapping.
+ */
+void
+BufferManagerShmemValidate(int targetNBuffers)
+{
+	bool		found;
+	void	   *tmpPtr;
+
+	/* Validate Buffer Descriptors */
+	tmpPtr = (BufferDescPadded *)
+		ShmemInitStructInSegment("Buffer Descriptors",
+								 MaxNBuffers * sizeof(BufferDescPadded),
+								 &found, MAIN_SHMEM_SEGMENT);
+	if (!found || BufferDescriptors != tmpPtr)
+		elog(FATAL, "validating buffer descriptors failed: expected pointer %p, got %p, found=%d",
+			 BufferDescriptors, tmpPtr, found);
+
+	/* Validate Buffer IO Condition Variables */
+	tmpPtr = (ConditionVariableMinimallyPadded *)
+		ShmemInitStructInSegment("Buffer IO Condition Variables",
+								 MaxNBuffers * sizeof(ConditionVariableMinimallyPadded),
+								 &found, MAIN_SHMEM_SEGMENT);
+	if (!found || BufferIOCVArray != tmpPtr)
+		elog(FATAL, "validating buffer IO condition variables failed: expected pointer %p, got %p, found=%d",
+			 BufferIOCVArray, tmpPtr, found);
+
+	/* Validate Checkpoint BufferIds */
+	tmpPtr = (CkptSortItem *)
+		ShmemInitStructInSegment("Checkpoint BufferIds",
+								 MaxNBuffers * sizeof(CkptSortItem), &found,
+								 MAIN_SHMEM_SEGMENT);
+	if (!found || CkptBufferIds != tmpPtr)
+		elog(FATAL, "validating checkpoint buffer IDs failed: expected pointer %p, got %p, found=%d",
+			 CkptBufferIds, tmpPtr, found);
+
+	/* Validate Buffer Blocks */
+	tmpPtr = (char *)
+		TYPEALIGN(PG_IO_ALIGN_SIZE,
+				  ShmemInitStructInSegment("Buffer Blocks",
+										   targetNBuffers * (Size) BLCKSZ + PG_IO_ALIGN_SIZE,
+										   &found, BUFFERS_SHMEM_SEGMENT));
+	if (!found || BufferBlocks != tmpPtr)
+		elog(FATAL, "validating buffer blocks failed: expected pointer %p, got %p, found=%d",
+			 BufferBlocks, tmpPtr, found);
+}
+
+/*
+ * check_shared_buffers
+ *		GUC check_hook for shared_buffers
+ *
+ * When reloading the configuration, shared_buffers should not be set to a value
+ * higher than max_shared_buffers fixed at the boot time.
+ */
+bool
+check_shared_buffers(int *newval, void **extra, GucSource source)
+{
+	if (finalMaxNBuffers && *newval > MaxNBuffers)
+	{
+		GUC_check_errdetail("\"shared_buffers\" must be less than \"max_shared_buffers\".");
+		return false;
+	}
+	return true;
+}
+
+/*
+ * show_shared_buffers
+ *		GUC show_hook for shared_buffers
+ *
+ * Shows both current and pending buffer counts with proper unit formatting.
+ */
+const char *
+show_shared_buffers(void)
+{
+	static char buffer[128];
+	int64		current_value,
+				pending_value;
+	const char *current_unit,
+			   *pending_unit;
+	int			currentNBuffers = pg_atomic_read_u32(&ShmemCtrl->currentNBuffers);
+
+	if (currentNBuffers == NBuffersPending)
+	{
+		/* No buffer pool resizing pending. */
+		convert_int_from_base_unit(currentNBuffers, GUC_UNIT_BLOCKS, &current_value, &current_unit);
+		snprintf(buffer, sizeof(buffer), INT64_FORMAT "%s", current_value, current_unit);
+	}
+	else
+	{
+		/*
+		 * Shared buffer pool is pending to be resized, show both current and
+		 * pending sizes.
+		 */
+		convert_int_from_base_unit(currentNBuffers, GUC_UNIT_BLOCKS, &current_value, &current_unit);
+		convert_int_from_base_unit(NBuffersPending, GUC_UNIT_BLOCKS, &pending_value, &pending_unit);
+		snprintf(buffer, sizeof(buffer), INT64_FORMAT "%s (pending: " INT64_FORMAT "%s)",
+				 current_value, current_unit, pending_value, pending_unit);
+	}
+
+	return buffer;
+}
